/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <stdio.h>
#include <strings.h>
#include <qmessagebox.h>
#include <qtextedit.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <qfile.h>

void settingsForm::init()
{
    FILE *ipsettingsfp;
    FILE *scenterfp;
    QString ip_str;
    QString scenter;
    char buf[256];
    char *homedir = new char[1024];
    char *ipfilename = new char[1024];
    char *scenterfilename = new char[1024];
    
    
    // Get path to the home directory
    homedir = getenv("HOME");
    strcpy(ipfilename, homedir);
    strcat(ipfilename, "/.qgnokii/config");
    strcpy(scenterfilename, homedir);
    strcat(scenterfilename, "/.qgnokii/scenter");
    
    // Open settings files
    if((ipsettingsfp = fopen(ipfilename, "r")) == NULL)
    {
	QMessageBox::warning(this, "Warning", "Settings file not found", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    if((scenterfp = fopen(scenterfilename, "r")) == NULL)
    {
	QMessageBox::warning(this, "Warning", "Settings file not found", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    
    // Get data from files...
    fgets(buf, sizeof(buf), ipsettingsfp);
    addressLineEdit->setText(buf);
    fgets(buf, sizeof(buf), scenterfp);
    scenterLineEdit->setText(buf);
    
    // ...and close them
    fclose(ipsettingsfp);
    fclose(scenterfp);
}

void settingsForm::saveSettingsSlot()
{
    FILE *ipsettingsfp;
    FILE *scenterfp;
    QString ip_str;
    QString scenter;
    char *homedir = new char[1024];
    char *ipfilename = new char[1024];
    char *scenterfilename = new char[1024];
    
    
    // Get path to the home directory
    homedir = getenv("HOME");
    strcpy(ipfilename, homedir);
    strcat(ipfilename, "/.qgnokii/config");
    strcpy(scenterfilename, homedir);
    strcat(scenterfilename, "/.qgnokii/scenter");
    
    // Open settings files
    if((ipsettingsfp = fopen(ipfilename, "w")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Internal error. Can't open settings file.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    if((scenterfp = fopen(scenterfilename, "w")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Internal error. Can't open settings file.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    
    // Write data into them and close them
    ip_str = addressLineEdit->text();
    fprintf(ipsettingsfp, "%s", ip_str.ascii());
    fclose(ipsettingsfp);
    scenter = scenterLineEdit->text();
    fprintf(scenterfp, "%s", scenter.ascii());
    fclose(scenterfp);
    this->close();
}
